package alinlp

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// GetSummaryChEcom invokes the alinlp.GetSummaryChEcom API synchronously
func (client *Client) GetSummaryChEcom(request *GetSummaryChEcomRequest) (response *GetSummaryChEcomResponse, err error) {
	response = CreateGetSummaryChEcomResponse()
	err = client.DoAction(request, response)
	return
}

// GetSummaryChEcomWithChan invokes the alinlp.GetSummaryChEcom API asynchronously
func (client *Client) GetSummaryChEcomWithChan(request *GetSummaryChEcomRequest) (<-chan *GetSummaryChEcomResponse, <-chan error) {
	responseChan := make(chan *GetSummaryChEcomResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.GetSummaryChEcom(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// GetSummaryChEcomWithCallback invokes the alinlp.GetSummaryChEcom API asynchronously
func (client *Client) GetSummaryChEcomWithCallback(request *GetSummaryChEcomRequest, callback func(response *GetSummaryChEcomResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *GetSummaryChEcomResponse
		var err error
		defer close(result)
		response, err = client.GetSummaryChEcom(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// GetSummaryChEcomRequest is the request struct for api GetSummaryChEcom
type GetSummaryChEcomRequest struct {
	*requests.RpcRequest
	ServiceCode string `position:"Body" name:"ServiceCode"`
	Text        string `position:"Body" name:"Text"`
}

// GetSummaryChEcomResponse is the response struct for api GetSummaryChEcom
type GetSummaryChEcomResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	Data      string `json:"Data" xml:"Data"`
}

// CreateGetSummaryChEcomRequest creates a request to invoke GetSummaryChEcom API
func CreateGetSummaryChEcomRequest() (request *GetSummaryChEcomRequest) {
	request = &GetSummaryChEcomRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("alinlp", "2020-06-29", "GetSummaryChEcom", "alinlp", "openAPI")
	request.Method = requests.POST
	return
}

// CreateGetSummaryChEcomResponse creates a response to parse from GetSummaryChEcom response
func CreateGetSummaryChEcomResponse() (response *GetSummaryChEcomResponse) {
	response = &GetSummaryChEcomResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
