package appstream_center

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// AuthorizeInstanceGroup invokes the appstream_center.AuthorizeInstanceGroup API synchronously
func (client *Client) AuthorizeInstanceGroup(request *AuthorizeInstanceGroupRequest) (response *AuthorizeInstanceGroupResponse, err error) {
	response = CreateAuthorizeInstanceGroupResponse()
	err = client.DoAction(request, response)
	return
}

// AuthorizeInstanceGroupWithChan invokes the appstream_center.AuthorizeInstanceGroup API asynchronously
func (client *Client) AuthorizeInstanceGroupWithChan(request *AuthorizeInstanceGroupRequest) (<-chan *AuthorizeInstanceGroupResponse, <-chan error) {
	responseChan := make(chan *AuthorizeInstanceGroupResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.AuthorizeInstanceGroup(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// AuthorizeInstanceGroupWithCallback invokes the appstream_center.AuthorizeInstanceGroup API asynchronously
func (client *Client) AuthorizeInstanceGroupWithCallback(request *AuthorizeInstanceGroupRequest, callback func(response *AuthorizeInstanceGroupResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *AuthorizeInstanceGroupResponse
		var err error
		defer close(result)
		response, err = client.AuthorizeInstanceGroup(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// AuthorizeInstanceGroupRequest is the request struct for api AuthorizeInstanceGroup
type AuthorizeInstanceGroupRequest struct {
	*requests.RpcRequest
	SpecId             string    `position:"Body" name:"SpecId"`
	UnAuthorizeUserIds *[]string `position:"Body" name:"UnAuthorizeUserIds"  type:"Repeated"`
	ProductType        string    `position:"Body" name:"ProductType"`
	AppInstanceGroupId string    `position:"Body" name:"AppInstanceGroupId"`
	AuthorizeUserIds   *[]string `position:"Body" name:"AuthorizeUserIds"  type:"Repeated"`
}

// AuthorizeInstanceGroupResponse is the response struct for api AuthorizeInstanceGroup
type AuthorizeInstanceGroupResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateAuthorizeInstanceGroupRequest creates a request to invoke AuthorizeInstanceGroup API
func CreateAuthorizeInstanceGroupRequest() (request *AuthorizeInstanceGroupRequest) {
	request = &AuthorizeInstanceGroupRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("appstream-center", "2021-09-01", "AuthorizeInstanceGroup", "", "")
	request.Method = requests.POST
	return
}

// CreateAuthorizeInstanceGroupResponse creates a response to parse from AuthorizeInstanceGroup response
func CreateAuthorizeInstanceGroupResponse() (response *AuthorizeInstanceGroupResponse) {
	response = &AuthorizeInstanceGroupResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
