package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryFailReasonList invokes the domain.QueryFailReasonList API synchronously
func (client *Client) QueryFailReasonList(request *QueryFailReasonListRequest) (response *QueryFailReasonListResponse, err error) {
	response = CreateQueryFailReasonListResponse()
	err = client.DoAction(request, response)
	return
}

// QueryFailReasonListWithChan invokes the domain.QueryFailReasonList API asynchronously
func (client *Client) QueryFailReasonListWithChan(request *QueryFailReasonListRequest) (<-chan *QueryFailReasonListResponse, <-chan error) {
	responseChan := make(chan *QueryFailReasonListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryFailReasonList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryFailReasonListWithCallback invokes the domain.QueryFailReasonList API asynchronously
func (client *Client) QueryFailReasonListWithCallback(request *QueryFailReasonListRequest, callback func(response *QueryFailReasonListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryFailReasonListResponse
		var err error
		defer close(result)
		response, err = client.QueryFailReasonList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryFailReasonListRequest is the request struct for api QueryFailReasonList
type QueryFailReasonListRequest struct {
	*requests.RpcRequest
	SaleId            string           `position:"Query" name:"SaleId"`
	DomainName        string           `position:"Query" name:"DomainName"`
	UserClientIp      string           `position:"Query" name:"UserClientIp"`
	Lang              string           `position:"Query" name:"Lang"`
	ContactTemplateId requests.Integer `position:"Query" name:"ContactTemplateId"`
}

// QueryFailReasonListResponse is the response struct for api QueryFailReasonList
type QueryFailReasonListResponse struct {
	*responses.BaseResponse
	RequestId string                    `json:"RequestId" xml:"RequestId"`
	Data      DataInQueryFailReasonList `json:"Data" xml:"Data"`
}

// CreateQueryFailReasonListRequest creates a request to invoke QueryFailReasonList API
func CreateQueryFailReasonListRequest() (request *QueryFailReasonListRequest) {
	request = &QueryFailReasonListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "QueryFailReasonList", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryFailReasonListResponse creates a response to parse from QueryFailReasonList response
func CreateQueryFailReasonListResponse() (response *QueryFailReasonListResponse) {
	response = &QueryFailReasonListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
