package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// QueryPurchasedDomains invokes the domain.QueryPurchasedDomains API synchronously
func (client *Client) QueryPurchasedDomains(request *QueryPurchasedDomainsRequest) (response *QueryPurchasedDomainsResponse, err error) {
	response = CreateQueryPurchasedDomainsResponse()
	err = client.DoAction(request, response)
	return
}

// QueryPurchasedDomainsWithChan invokes the domain.QueryPurchasedDomains API asynchronously
func (client *Client) QueryPurchasedDomainsWithChan(request *QueryPurchasedDomainsRequest) (<-chan *QueryPurchasedDomainsResponse, <-chan error) {
	responseChan := make(chan *QueryPurchasedDomainsResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.QueryPurchasedDomains(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// QueryPurchasedDomainsWithCallback invokes the domain.QueryPurchasedDomains API asynchronously
func (client *Client) QueryPurchasedDomainsWithCallback(request *QueryPurchasedDomainsRequest, callback func(response *QueryPurchasedDomainsResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *QueryPurchasedDomainsResponse
		var err error
		defer close(result)
		response, err = client.QueryPurchasedDomains(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// QueryPurchasedDomainsRequest is the request struct for api QueryPurchasedDomains
type QueryPurchasedDomainsRequest struct {
	*requests.RpcRequest
	UpdateTimeOrder    requests.Boolean `position:"Body" name:"UpdateTimeOrder"`
	DomainName         string           `position:"Body" name:"DomainName"`
	CurrentPage        requests.Integer `position:"Body" name:"CurrentPage"`
	ProductType        requests.Integer `position:"Body" name:"ProductType"`
	OperationStatus    requests.Integer `position:"Body" name:"OperationStatus"`
	StartOperationTime string           `position:"Body" name:"StartOperationTime"`
	PageSize           requests.Integer `position:"Body" name:"PageSize"`
	EndOperationTime   string           `position:"Body" name:"EndOperationTime"`
	OpTimeOrder        requests.Boolean `position:"Body" name:"OpTimeOrder"`
}

// QueryPurchasedDomainsResponse is the response struct for api QueryPurchasedDomains
type QueryPurchasedDomainsResponse struct {
	*responses.BaseResponse
	RequestId      string             `json:"RequestId" xml:"RequestId"`
	TotalItemNum   int                `json:"TotalItemNum" xml:"TotalItemNum"`
	CurrentPageNum int                `json:"CurrentPageNum" xml:"CurrentPageNum"`
	PageSize       int                `json:"PageSize" xml:"PageSize"`
	TotalPageNum   int                `json:"TotalPageNum" xml:"TotalPageNum"`
	Data           []PurchasedDomains `json:"Data" xml:"Data"`
}

// CreateQueryPurchasedDomainsRequest creates a request to invoke QueryPurchasedDomains API
func CreateQueryPurchasedDomainsRequest() (request *QueryPurchasedDomainsRequest) {
	request = &QueryPurchasedDomainsRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2018-02-08", "QueryPurchasedDomains", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateQueryPurchasedDomainsResponse creates a response to parse from QueryPurchasedDomains response
func CreateQueryPurchasedDomainsResponse() (response *QueryPurchasedDomainsResponse) {
	response = &QueryPurchasedDomainsResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
