package domain

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// SaveTaskForSubmittingDomainNameCredential invokes the domain.SaveTaskForSubmittingDomainNameCredential API synchronously
func (client *Client) SaveTaskForSubmittingDomainNameCredential(request *SaveTaskForSubmittingDomainNameCredentialRequest) (response *SaveTaskForSubmittingDomainNameCredentialResponse, err error) {
	response = CreateSaveTaskForSubmittingDomainNameCredentialResponse()
	err = client.DoAction(request, response)
	return
}

// SaveTaskForSubmittingDomainNameCredentialWithChan invokes the domain.SaveTaskForSubmittingDomainNameCredential API asynchronously
func (client *Client) SaveTaskForSubmittingDomainNameCredentialWithChan(request *SaveTaskForSubmittingDomainNameCredentialRequest) (<-chan *SaveTaskForSubmittingDomainNameCredentialResponse, <-chan error) {
	responseChan := make(chan *SaveTaskForSubmittingDomainNameCredentialResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.SaveTaskForSubmittingDomainNameCredential(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// SaveTaskForSubmittingDomainNameCredentialWithCallback invokes the domain.SaveTaskForSubmittingDomainNameCredential API asynchronously
func (client *Client) SaveTaskForSubmittingDomainNameCredentialWithCallback(request *SaveTaskForSubmittingDomainNameCredentialRequest, callback func(response *SaveTaskForSubmittingDomainNameCredentialResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *SaveTaskForSubmittingDomainNameCredentialResponse
		var err error
		defer close(result)
		response, err = client.SaveTaskForSubmittingDomainNameCredential(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// SaveTaskForSubmittingDomainNameCredentialRequest is the request struct for api SaveTaskForSubmittingDomainNameCredential
type SaveTaskForSubmittingDomainNameCredentialRequest struct {
	*requests.RpcRequest
	CredentialType string `position:"Query" name:"CredentialType"`
	SaleId         string `position:"Query" name:"SaleId"`
	DomainName     string `position:"Query" name:"DomainName"`
	CredentialNo   string `position:"Query" name:"CredentialNo"`
	Credential     string `position:"Query" name:"Credential"`
	UserClientIp   string `position:"Query" name:"UserClientIp"`
	Lang           string `position:"Query" name:"Lang"`
}

// SaveTaskForSubmittingDomainNameCredentialResponse is the response struct for api SaveTaskForSubmittingDomainNameCredential
type SaveTaskForSubmittingDomainNameCredentialResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
	TaskNo    string `json:"TaskNo" xml:"TaskNo"`
}

// CreateSaveTaskForSubmittingDomainNameCredentialRequest creates a request to invoke SaveTaskForSubmittingDomainNameCredential API
func CreateSaveTaskForSubmittingDomainNameCredentialRequest() (request *SaveTaskForSubmittingDomainNameCredentialRequest) {
	request = &SaveTaskForSubmittingDomainNameCredentialRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("Domain", "2016-05-11", "SaveTaskForSubmittingDomainNameCredential", "domain", "openAPI")
	request.Method = requests.POST
	return
}

// CreateSaveTaskForSubmittingDomainNameCredentialResponse creates a response to parse from SaveTaskForSubmittingDomainNameCredential response
func CreateSaveTaskForSubmittingDomainNameCredentialResponse() (response *SaveTaskForSubmittingDomainNameCredentialResponse) {
	response = &SaveTaskForSubmittingDomainNameCredentialResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
