package ltl

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeMPCoSAuthorizedInfo invokes the ltl.DescribeMPCoSAuthorizedInfo API synchronously
func (client *Client) DescribeMPCoSAuthorizedInfo(request *DescribeMPCoSAuthorizedInfoRequest) (response *DescribeMPCoSAuthorizedInfoResponse, err error) {
	response = CreateDescribeMPCoSAuthorizedInfoResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeMPCoSAuthorizedInfoWithChan invokes the ltl.DescribeMPCoSAuthorizedInfo API asynchronously
func (client *Client) DescribeMPCoSAuthorizedInfoWithChan(request *DescribeMPCoSAuthorizedInfoRequest) (<-chan *DescribeMPCoSAuthorizedInfoResponse, <-chan error) {
	responseChan := make(chan *DescribeMPCoSAuthorizedInfoResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeMPCoSAuthorizedInfo(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeMPCoSAuthorizedInfoWithCallback invokes the ltl.DescribeMPCoSAuthorizedInfo API asynchronously
func (client *Client) DescribeMPCoSAuthorizedInfoWithCallback(request *DescribeMPCoSAuthorizedInfoRequest, callback func(response *DescribeMPCoSAuthorizedInfoResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeMPCoSAuthorizedInfoResponse
		var err error
		defer close(result)
		response, err = client.DescribeMPCoSAuthorizedInfo(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeMPCoSAuthorizedInfoRequest is the request struct for api DescribeMPCoSAuthorizedInfo
type DescribeMPCoSAuthorizedInfoRequest struct {
	*requests.RpcRequest
	PhaseGroupId string `position:"Query" name:"PhaseGroupId"`
	ApiVersion   string `position:"Query" name:"ApiVersion"`
	BizChainId   string `position:"Query" name:"BizChainId"`
	MemberId     string `position:"Query" name:"MemberId"`
}

// DescribeMPCoSAuthorizedInfoResponse is the response struct for api DescribeMPCoSAuthorizedInfo
type DescribeMPCoSAuthorizedInfoResponse struct {
	*responses.BaseResponse
	Code      int    `json:"Code" xml:"Code"`
	Message   string `json:"Message" xml:"Message"`
	RequestId string `json:"RequestId" xml:"RequestId"`
	Success   bool   `json:"Success" xml:"Success"`
	Data      Data   `json:"Data" xml:"Data"`
}

// CreateDescribeMPCoSAuthorizedInfoRequest creates a request to invoke DescribeMPCoSAuthorizedInfo API
func CreateDescribeMPCoSAuthorizedInfoRequest() (request *DescribeMPCoSAuthorizedInfoRequest) {
	request = &DescribeMPCoSAuthorizedInfoRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("ltl", "2019-05-10", "DescribeMPCoSAuthorizedInfo", "", "")
	request.Method = requests.POST
	return
}

// CreateDescribeMPCoSAuthorizedInfoResponse creates a response to parse from DescribeMPCoSAuthorizedInfo response
func CreateDescribeMPCoSAuthorizedInfoResponse() (response *DescribeMPCoSAuthorizedInfoResponse) {
	response = &DescribeMPCoSAuthorizedInfoResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
