package retailadvqa_public

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// NewListMenu invokes the retailadvqa_public.NewListMenu API synchronously
func (client *Client) NewListMenu(request *NewListMenuRequest) (response *NewListMenuResponse, err error) {
	response = CreateNewListMenuResponse()
	err = client.DoAction(request, response)
	return
}

// NewListMenuWithChan invokes the retailadvqa_public.NewListMenu API asynchronously
func (client *Client) NewListMenuWithChan(request *NewListMenuRequest) (<-chan *NewListMenuResponse, <-chan error) {
	responseChan := make(chan *NewListMenuResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.NewListMenu(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// NewListMenuWithCallback invokes the retailadvqa_public.NewListMenu API asynchronously
func (client *Client) NewListMenuWithCallback(request *NewListMenuRequest, callback func(response *NewListMenuResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *NewListMenuResponse
		var err error
		defer close(result)
		response, err = client.NewListMenu(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// NewListMenuRequest is the request struct for api NewListMenu
type NewListMenuRequest struct {
	*requests.RpcRequest
	AccessId    string `position:"Query" name:"AccessId"`
	TenantId    string `position:"Query" name:"TenantId"`
	RoleSign    string `position:"Query" name:"RoleSign"`
	WorkspaceId string `position:"Query" name:"WorkspaceId"`
}

// NewListMenuResponse is the response struct for api NewListMenu
type NewListMenuResponse struct {
	*responses.BaseResponse
	RequestId string     `json:"RequestId" xml:"RequestId"`
	ErrorDesc string     `json:"ErrorDesc" xml:"ErrorDesc"`
	TraceId   string     `json:"TraceId" xml:"TraceId"`
	ErrorCode string     `json:"ErrorCode" xml:"ErrorCode"`
	Success   bool       `json:"Success" xml:"Success"`
	Data      []DataItem `json:"Data" xml:"Data"`
}

// CreateNewListMenuRequest creates a request to invoke NewListMenu API
func CreateNewListMenuRequest() (request *NewListMenuRequest) {
	request = &NewListMenuRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("retailadvqa-public", "2020-05-15", "NewListMenu", "", "")
	request.Method = requests.POST
	return
}

// CreateNewListMenuResponse creates a response to parse from NewListMenu response
func CreateNewListMenuResponse() (response *NewListMenuResponse) {
	response = &NewListMenuResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
